/* ActionPanel.java:
 * 	User Interface ActionPanel class. 
 *	Holds action lists and the player's action.
 */

package ORG.ebiss.sara.client;

import java.awt.*;
import java.applet.Applet;
import java.util.Hashtable;
import java.util.Enumeration;
import ORG.ebiss.sara.server.Interaction;
import ORG.ebiss.sara.server.SimValueAdapter;

import java.awt.event.*;
import com.sun.java.swing.*;

public class ActionPanel extends ListPanel {
    private Hashtable actTable = new Hashtable(20);  // action table 
    private SimValueAdapter adapter; 
    private Client top;

    ActionPanel(SimValueAdapter adapter, Client top) {
	this.adapter = adapter;
	this.top = top;
	validate();
    }

    public synchronized void addAction(Interaction i) {
	actTable.put(i.getDescription(), i);
	addListItem(new ListButton(i.getDescription()));
	Log.log("Accepted interaction: " + actTable.get(i.getDescription()));
	repaint();
    }

    public synchronized void delAction(Interaction i) {
	try {
	    actTable.remove(i.getDescription());
	} catch (NullPointerException e) {
	    Log.error("ActionPanel.rmAction: NullPointerException");
	}
	removeAll();
	Enumeration enum = actTable.elements();
	ListButton[] buttons = new ListButton[actTable.size()]; 
	int count = 0;
	while (enum.hasMoreElements()) {
	    buttons[count] =
		new ListButton(((Interaction) enum.nextElement()).getDescription());
	    count++;
	}
	addListItems(buttons);
	repaint();
    }

    private  void addListItems(ListButton[] buttons){
	for(int i = 0; i < buttons.length; i ++){
	    addListItem(buttons[i]);
	}
    }
  
    private void addListItem(ListButton button){
	button.addActionListener(new ActionHandler());
	addList(button);
	validate();
    }


    /* Handle interaction selection. 
     * The user selects an interaction in the action panel. 
     * Get the interaction from the interaction table, and 
     * interact with player. 
     */
    class ActionHandler implements ActionListener{
	public void actionPerformed(ActionEvent event){
	    ListButton selected = (ListButton)event.getSource();
	    String s = selected.getText();
	    Interaction i = (Interaction)actTable.get(s);
	    new InteractThread(adapter,i, top);
	    Log.log("Activating: " + s);
	}
    }

}




