package ORG.ebiss.sara.client;

import java.awt.*;
import java.util.Enumeration;
import java.util.Vector;
import ORG.ebiss.sara.server.UICheckBox;

import com.sun.java.swing.*;

/**
 * Checkbox Parameter
 *
 */

class CheckboxParam extends ParamView {
  private Vector cbList = new Vector();
  private String checkedContents = "";

  CheckboxParam (UICheckBox p) {
    super(p);

    JPanel cbp = new JPanel(); 
    cbp.setLayout(new GridLayout(0,1));
    if (argName != null) cbp.add(argName);

    String s;
    JCheckBox cb;
    for (Enumeration enum = p.elements(); enum.hasMoreElements();) {
      s = (String) enum.nextElement(); 
      cb = new JCheckBox(s);
      cb.setFont(Client.FONT);
      cb.setSelected(p.isChecked(s)? true : false);
      cbList.addElement(cb);
      cbp.add(cb);
    }
    add(cbp);
  }

  public boolean valid() {
/*
    JCheckBox cb;
    for (int i=0; i < cbList.size(); i++) {
      // at least one box checked 
      cb = (JCheckBox) cbList.elementAt(i);
      if (cb.getState()) return true;
    }
    return false;  // no box checked 
*/
    return true;   // allowed to have no box checked
  }

  public void setValue() {
    JCheckBox cb;
    for (int i=0; i < cbList.size(); i++) {
      cb = (JCheckBox) cbList.elementAt(i);
      ((UICheckBox) param).check(cb.getText(),
					     cb.isSelected());
      Log.log("Set checkbox values");
      checkedContents = 
	checkedContents.concat(cb.getText() + "  is  " +
			       cb.isSelected() + "\n");
    }
  }

  public String toString(){
    return (getDescription() + "\n\n# This is Your Input #\n\n" + 
	    checkedContents);
  }

  public void setEnabled(boolean b){
    JCheckBox cb;
    for (int i=0; i < cbList.size(); i++) {
      cb = (JCheckBox) cbList.elementAt(i);
      cb.setEnabled(b);
    }
  }

}








