package ORG.ebiss.sara.client;

import java.awt.*;
import java.util.Enumeration;
import ORG.ebiss.sara.server.UIObject;
import ORG.ebiss.sara.server.CompositeUIObject;

import java.awt.event.*;
import com.sun.java.swing.*;

/**
 * Checkbox Parameter
 *   Used instead of RadioButtonParam for it occupies less space.
 */

class ChoiceParam extends ParamView {
  private JComboBox choice;
  private boolean hasAnyItem = false;

  ChoiceParam (UIObject p) {
    super(p);   

    choice = new JComboBox();
    choice.setFont(Client.FONT);
    choice.addActionListener(new ChoiceSelection());
    choice.setEditable(false);

    String chosen = p.toString(); // the default value
    value = chosen; 
    // use default FlowLayout
    if (argName != null) add(argName);

    Enumeration enum = ((CompositeUIObject) p).elements();
    while (enum.hasMoreElements()) {
      String s = (String)enum.nextElement(); 
      choice.addItem(s);
      hasAnyItem = true;
    }
    if(hasAnyItem){
      add(choice);
    }
    else{
      JLabel l = new JLabel("There is No Item");
      l.setFont(Client.FONT);
      add(l);
    }
    if(!chosen.equals("")){
      choice.setSelectedItem(chosen);
    }
  }

  /*
   * Get the argument. 
   */
  class ChoiceSelection implements ActionListener{
    public void actionPerformed(ActionEvent e){
      if(!hasAnyItem){
	return;
      }
      JComboBox cb = (JComboBox)e.getSource();
      value = (String)cb.getSelectedItem();
    }
  }

  public void setEnabled(boolean b){
    choice.setEnabled(b);
  }

}
