/* InformFrame.java:
 * 	Interactin of type "show".
 */

package ORG.ebiss.sara.client;

import java.awt.*;
import ORG.ebiss.sara.server.*;
import java.awt.event.*;
import com.sun.java.swing.*;


public class InformFrame extends JFrame{ // implements DialogClient {
  public static final int IPANEL_COLS = 35;    // text area 
  public static final int IPANEL_ROWS = 30;

  private final Color _color = new Color(00, 132, 187);

  public final int FRAME_WIDTH = 300;
  public final int FRAME_HEIGHT = 200;

  private JPanel panel;   // internal panel to be scrolled
  private JButton closeButton;	
  private Client topApp;

  private Container pane;

  InformFrame(Client client) {
    super("Inform Frame");
    topApp = client;
    pane = getContentPane();
  }      

  /* Reset current interaction
   */
  public void resetInteraction () {
    setVisible(false);
    dispose();
  }

  /* inform:
   *	Display a message in the interaction frame. No
   *	parameters are needed. 
   */
  public synchronized void inform(UIObject i) {
    panel = new JPanel();

    Log.log("Show: " + i.toString());
    panel.setLayout(new GridLayout(0,1));
    panel.add(Util.obj2view(i,IPANEL_COLS));
    topApp.keepInform(i.toString(), this);
    makeFrame(panel);
  }

  public void makeFrame(JPanel panel){
    pane.add(panel, BorderLayout.CENTER);

    closeButton = new JButton("Close");
    closeButton.addActionListener(new CloseInform());
    JPanel panelOut = new JPanel();
    JPanel panelIn = new JPanel();
    panelIn.add(closeButton);
    panelOut.setLayout(new BorderLayout(0,5));
    panelOut.add("Center", panelIn);
    pane.add(panelOut, BorderLayout.SOUTH);

    int width, height;
    width = getPreferredSize().width;
    height = getPreferredSize().height;
    if(width < FRAME_WIDTH)
      width = FRAME_WIDTH;
    if(height < FRAME_HEIGHT)
      height = FRAME_HEIGHT;
    setSize(width, height);
    setVisible(true);


    Point point = topApp.getFrameLocationToBe(width, height);
    setLocation(point.x, point.y);

    setBackground(_color);
  }

  /* button events */
  class CloseInform implements ActionListener{
    public void actionPerformed(ActionEvent event){
      resetInteraction();
    }
  }

  public Insets getInsets() {
    return new Insets(50, 20, 20, 20);
  }
}







