/**
 * Interaction Thread
 *
 *	The thread that consumes direct interactions.
 *	It shares an interaction queue with agent observer. 
 *	There should exist one InteractThread per each direct 
 *	interaction. 
 */

package ORG.ebiss.sara.client;


import ORG.ebiss.sara.server.UIObject;
import ORG.ebiss.sara.server.SimValueAdapter;
import ORG.ebiss.sara.server.Interaction;

public class InteractThread extends Thread {
  private InteractFrame iFrame;
  private Interaction interaction;
  private SimValueAdapter adapter;
  private Client top;

  public InteractThread (SimValueAdapter adapter, Interaction i, Client top) {
    interaction = i;
    this.adapter = adapter;
    this.top = top;
    start();
  }

  public void run() {
    if(top.getInteractList() != null){
      top.disposeInteractList();
    }
    iFrame = new InteractFrame(adapter);
    iFrame.setClient(top);
    iFrame.interact(interaction);
/*
    while (Thread.currentThread() == this) {
      try {
	sleep(1000);
      } catch (InterruptedException e){ }
    }
*/
  }
}
