package ORG.ebiss.sara.client;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import com.sun.java.swing.*;
import com.sun.java.swing.border.*;

/*
 * Buttton for using in ListPanel
 * Set Label Left Side
 *
 */

public class ListButton extends JComponent{
  private Vector listeners;
  private String actionCommand = "action";
  private Border raised, lowered;
  
  public ListButton(String text){
    listeners = new Vector();
    actionCommand = text;
    setLayout(new GridLayout(0, 1));
    JLabel label = new JLabel("  " + text, JLabel.LEFT);
    label.setFont(Client.FONT);
    add(label);
    raised = new BevelBorder(BevelBorder.RAISED);
    lowered = new BevelBorder(BevelBorder.LOWERED); 
    setBorder(raised);
    enableEvents(AWTEvent.MOUSE_EVENT_MASK);
  }

  protected void processMouseEvent(MouseEvent e){
    if(e.getID() == MouseEvent.MOUSE_PRESSED){
      setBorder(lowered);
      validate();
      repaint();
    }
    if(e.getID() == MouseEvent.MOUSE_RELEASED){
      int id = ActionEvent.ACTION_PERFORMED;
      ActionEvent event = new ActionEvent(this, id, actionCommand);
      for(int i = 0; i < listeners.size(); i ++){
	ActionListener listener =
	  (ActionListener)listeners.elementAt(i);
	listener.actionPerformed(event);
	setBorder(raised);
	validate();
	repaint();
      }
    }
    super.processMouseEvent(e);
  }

  public void addActionListener(ActionListener listener){
    listeners.addElement(listener);
  }

  public void setActionCommand(String actionCommand){
    this.actionCommand = actionCommand;
  }

  public String getActionCommand(){
    return actionCommand;
  }

  public String getText(){
    return actionCommand;
  }


}
