package ORG.ebiss.sara.client;

import java.awt.*;
import ORG.ebiss.sara.server.UIObject;

import com.sun.java.swing.*;

/** 
 * ParamView.
 * 	Parameter views. The base class for parameter values.
 */

class ParamView extends JPanel {
  protected Component argName = null;     
  protected UIObject param;
  protected static int maxCols;
  protected static int maxRows;
  protected String value = "";  // input value
  protected String defaultVal;

  protected JScrollPane scroll;

  ParamView (UIObject p) {
    param = p;
    defaultVal = p.toString();
    maxCols = InteractFrame.IPANEL_COLS -1;
    maxRows = InteractFrame.IPANEL_ROWS -1;
    String description = p.getDescription();

    if (description != "")
      argName = Util.splitLabel(description, maxCols);

  }

  protected String value() {
    return value;
  }

  // this is to be overhidden.
  public boolean valid() {
    if (value.equals("")) {
      return false; 
    } 
    return true;
  }

  // this is to be overRidden
  public void setEnabled(boolean b){
  }


  /* setParameter:
   *	Set the value of parameter. 
   */

  public void setValue() {
    param.setValueOf(value());
    Log.log("Set arg: " + value());
  }

  protected void setValue(String value){
    this.value = value;
  }

  public String getDescription() {
    return param.getDescription();
  }

  public String toString(){
    return getDescription() + "\n\n# This is Your Input #\n\n" + value() +"\n\n";
  }


}







