package ORG.ebiss.sara.client;

import java.awt.*;
import java.util.Hashtable;
import ORG.ebiss.sara.server.UIObject;
import java.awt.event.*;
import com.sun.java.swing.*;


/**
 * PropPanel.
 *   Properties panel. 
 *   Layout self describing objects in columns. 
 */

public class PropPanel extends ListPanel {
   /* defaults */
  private final int _textCols = 20;  // text columns

  /* Table of (property-name, awt-component) pairs */
  private Hashtable propTable = new Hashtable(20); // initially, 20.

  public void addProperty(String propName, 
			  UIObject prop) {
    String descr = prop.getDescription();
    if (propTable.containsKey(propName)) {  // update
      /* Avoid rapainting the panel at every day tick. */
      if ( propName.equals("keika-nissuu") &&
	  (Integer.parseInt(prop.toString()) % 10) != 0)  return;
      
      Log.log("Updating property: " + descr);
      remove((Component)propTable.remove(propName));
    } else {				// new property
      Log.log("Adding property: " + descr);
    }
    Component c = Util.obj2view(prop, _textCols);
    propTable.put(propName, c);
    addList(c);
    validate();
  }

  public void delProperty(String propName) {
    try {
      Component c = (Component) propTable.remove(propName);
      remove(c);
    } catch (NullPointerException e) {
      Log.error("PropPanel.delProperty: " + e);
    }
  }

  public Insets getInsets() {
    return new Insets(5,5,5,5);
  }
}

