package ORG.ebiss.sara.client;

import java.awt.*;
import java.util.Enumeration;
import java.util.Vector;
import ORG.ebiss.sara.server.UIObject;
import ORG.ebiss.sara.server.CompositeUIObject;

import java.awt.event.*;
import com.sun.java.swing.*;

/**
 * Radio Button parameter.
 *
 */

class RadioButtonParam extends ParamView {

  private ButtonGroup bGroup = new ButtonGroup();
  private Vector rbList = new Vector();

  RadioButtonParam (UIObject p) {
    super(p);
    // setLayout(new GridLayout(1,2)); // indefinite rows, 1 column
    if (argName != null) add(argName);

    /* use the default flow-layout for the checkbox'es */
    JPanel rbp = new JPanel(); 
    rbp.setLayout(new GridLayout(0,1));
    Enumeration enum = ((CompositeUIObject) p).elements();
    String chosen = p.toString();
    value = chosen; // the default clicked checkbox;

    while (enum.hasMoreElements()) {
      String s = (String) enum.nextElement(); 
      JRadioButton rb = new JRadioButton(s, s.equals(chosen)? true:false);
      rb.setFont(Client.FONT);
      rb.addActionListener(new RadioButtonSelection());
      bGroup.add(rb);
      rbList.addElement(rb);
      rbp.add(rb);
    }
    add(rbp);
  }

  /* Gets the argument. 
   *	CAVEAT! I am assuming there's only one checkbox parameter
   *		in the interaction, which may not always be the case.
   */
  class RadioButtonSelection implements ActionListener{
    public void actionPerformed(ActionEvent e){
      JRadioButton rb = (JRadioButton)e.getSource();
      value = rb.getText();
      Log.log("Get arg: " + value);
    }
  }
  
  public void setEnabled(boolean b){
    JRadioButton rb;
    for (int i=0; i < rbList.size(); i++) {
      rb = (JRadioButton)rbList.elementAt(i);
      rb.setEnabled(b);
    }
  }


}
