package ORG.ebiss.sara.client;

import java.io.*;
import java.net.*;
import java.awt.*;
import ORG.ebiss.sara.server.UIObject;
import ORG.ebiss.sara.server.SimValueAdapter;
import ORG.ebiss.sara.server.RemoteObserver;
import ORG.ebiss.sara.server.Interaction;
import ORG.ebiss.sara.server.AgentAdapter;
import java.util.Hashtable;
import java.util.Vector;

import java.awt.event.*;
import com.sun.java.swing.*;
import com.sun.java.swing.border.*;


public class SituationPanel extends JPanel implements RemoteObserver {
    private AgentAdapter adapter; // the interface to server

    private final int WIDTH = 400;
    private final int HEIGHT = 400;
  
    /* coming soon */
    private PropPanel propPanel;
    private EventPanel eventPanel;
    private RecordPanel recPanel;
    private ActionPanel actPanel;

    private String name;

    public SituationPanel(String name, SimValueAdapter adapter, Client top){
	this.name = name;
	setLayout(new GridLayout(0,2));
	
	propPanel = new PropPanel();
	actPanel = new ActionPanel(adapter, top);
	recPanel = new RecordPanel();
	eventPanel = new EventPanel();
	
	addPanel("Situation Properties", propPanel);
	addPanel("Speaking Record", recPanel);
	addPanel("Actions", actPanel);
	addPanel("Event", eventPanel);
	
	setSize(WIDTH, HEIGHT);

	adapter.addObserver(this);
    }

    private void addPanel(String title, JPanel target){
	JPanel panel = new JPanel();    
	panel.setLayout(new GridLayout(0,1));
	panel.setFont(Client.FONT);
	panel.setBorder(new TitledBorder(title));
	JScrollPane scroll = 
	    new JScrollPane(target,
			    ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS,
			    ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);
	panel.add(scroll);
	add(panel);
    }

    public PropPanel getPropertyPanel(){
	return propPanel;
    }
    public ActionPanel getActionPanel(){
	return actPanel;
    }
    public RecordPanel getRecordPanel(){
	return recPanel;
    }
    public EventPanel getEventPanel(){
	return eventPanel;
    }

    /******************* RemoteObserver  ******************/

    public void acceptInformation(SimValueAdapter adapter,
				  UIObject contents){
    }

    public void acceptExtendedInformation(SimValueAdapter adapter,
					  String[] type,
					  UIObject contents){
      System.out.println("accept extended information: type=" + type[0]);
      acceptProperty(adapter, type[0], contents);
    }

    /* set Agents, Records, Events ... */

    public void acceptProperty(SimValueAdapter adapter,
			       String name, UIObject property){
	propPanel.addProperty(name, property);
    }
    public void retractProperty(SimValueAdapter adapter, String name){
	propPanel.delProperty(name);
	repaint();
    }

    public void acceptInteraction(SimValueAdapter adapter, Interaction i){
	switch(i.tag()) {
	case Interaction.TAG_DIRECT_INTERACTION: 
	    break;
	default: 
	    // TAG_CHAT, TAG_PROPOSE, TAG_DELEGATE, TAG_RESPONCE_TO_PROPOSAL
	    actPanel.addAction(i);
	    break;
	} 
	repaint();
    }
    public void retractInteraction(SimValueAdapter adapter, Interaction i){
	actPanel.delAction(i);
    }
  
    public void dispose(SimValueAdapter adapter){
	adapter.removeObserver(this);
    }


    /* Record of Speakings */
    class RecordPanel extends ListPanel{
    }

    /* Record of Events */
    class EventPanel extends ListPanel{
    }
  
}




