package ORG.ebiss.sara.client;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import com.sun.java.swing.*;
import com.sun.java.swing.border.*;
import com.sun.java.swing.event.*;
import ORG.ebiss.sara.server.UIObject;
import ORG.ebiss.sara.server.Slider;

class Slidebar extends ParamView {
  private int svalue;
  private String label;
  private JSlider sl;
  private JTextField tx;

  Slidebar (UIObject s) {
    super(s);
    System.out.println("Slidebar called");
    value = defaultVal;
    setLayout(new FlowLayout(FlowLayout.RIGHT));
    
    sl = new JSlider( JSlider.HORIZONTAL, 1, 10, Integer.parseInt(defaultVal));
    tx = new JTextField(defaultVal,3);
    
    sl.addChangeListener(new SliderEvent(tx));
    tx.addActionListener(new TextFieldResponse(sl));

    sl.setFont(Client.FONT);
    tx.setFont(Client.FONT); 

    if (argName != null){
      argName.setFont(Client.FONT);
      add(argName);
    }
    add(sl);
    add(tx);
    
    setSize(300,100);
    setVisible(true);
  }
  
  public void setEnabled(boolean b){
    tx.setEditable(b);
    sl.setEnabled(b);
  }
  
  class TextFieldResponse implements ActionListener {
    private JSlider sl;
    TextFieldResponse( JSlider sl ){ this.sl = sl; }
    public void actionPerformed( ActionEvent e ){
      JTextField tf = (JTextField)e.getSource();
      String s = tf.getText();
      int i;
      try{
	i = Integer.parseInt( s );
      }catch(NumberFormatException ex){
	System.out.println(ex);
	tx.setText(value);
	return;
      }
      sl.setValue( i );
      value = s;
    }
  }
  
  
  class SliderEvent implements ChangeListener {
    private JTextField tx;
    SliderEvent( JTextField tx ){ this.tx = tx; }
    public void stateChanged( ChangeEvent e ){
      JSlider sl = (JSlider)e.getSource();
      int i = sl.getValue();
      String s = Integer.toString(i);
      tx.setText(s);
      value = s;
    }
  }
}


