package ORG.ebiss.sara.client;

import java.awt.*;
import ORG.ebiss.sara.server.UIObject;

import com.sun.java.swing.*;

/**
 * TextArea parameter.
 *
 */

class TextAreaParam extends ParamView {

  private JTextArea arg;      // player's input component

  TextAreaParam (UIObject p) {
    super(p); 
    GridBagLayout layout = new GridBagLayout();
    GridBagConstraints c = new GridBagConstraints();
    setLayout(layout); 
    c.fill = GridBagConstraints.HORIZONTAL;
    c.gridwidth = GridBagConstraints.REMAINDER;
    c.weightx = 1.0;
    c.weighty = 0;
    if (argName != null) {
      layout.setConstraints(argName, c);
      add(argName);
    }
    if (defaultVal != null) {
      arg = new JTextArea(defaultVal,5,maxCols);
    } else {
      arg = new JTextArea(5,maxCols);
    }
    arg.setFont(Client.FONT);
    scroll = new JScrollPane(arg,
			     ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS,
			     ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);
    c.fill = GridBagConstraints.HORIZONTAL;
    c.weightx = 1.0;
    c.weighty = 1.0;
    layout.setConstraints(scroll, c);
    add(scroll);
  }

  /* This fix a bug in netscape where newlines comes as \ufffd,
   * when LANG=ja_JP.EUC 
   */

  private String fixnewline(String s) {
    return s.replace('\ufffd', '\n');
  }

  /* Get the argument. Overhides super's method. */

  public String value() {
//    value = arg.getText();
//    return fixnewline(value);
    return arg.getText();
  }

  public boolean valid() {
    if (value().equals("")) {
      // it seems that the server doesn't accept null strings.
      value = " "; 
    } 
    return true;
  }

  public void setEnabled(boolean b){
    arg.setEditable(b);
  }

}
