package ORG.ebiss.sara.client;

import java.awt.*;
import ORG.ebiss.sara.server.UIObject;

import java.awt.event.*;
import com.sun.java.swing.*;

/**
 * TextField parameter.
 *
 */

class TextFieldParam extends ParamView {

  private JTextField arg;     // player's input component

  TextFieldParam (UIObject p) {
    super(p);   // the super class constructor 
    GridBagLayout layout = new GridBagLayout();
    GridBagConstraints c = new GridBagConstraints();
    setLayout(layout); 
    c.fill = GridBagConstraints.HORIZONTAL;
    c.gridwidth = GridBagConstraints.REMAINDER;
    c.weightx = 1.0;
    c.weighty = 0;
    if (argName != null) {
      layout.setConstraints(argName, c);
      add(argName); 
    }
    if (defaultVal != null) {
      arg = new JTextField(defaultVal,maxCols);
    } else {
      arg = new JTextField(maxCols);
    }
    arg.setFont(Client.FONT);
    arg.addActionListener(new TextFieldParamListener());
    c.fill = GridBagConstraints.HORIZONTAL;
    c.weightx = 1.0;
    c.weighty = 1.0;
    layout.setConstraints(arg, c);
    add(arg);
  }

  public boolean valid() {
    if (value().equals("")) {
      // it seems that the server doesn't accept null strings.
      value = " "; 
    } 
    return true;
  }
  
  /* Get the argument. Overhides super's method. */
  
  public String value() {
    return arg.getText();
  }
  

  class TextFieldParamListener implements ActionListener{
    public void actionPerformed(ActionEvent e){
      setValue(arg.getText());
    }
  }

  public void setEnabled(boolean b){
    arg.setEditable(b);
  }

  
}



