package ORG.ebiss.sara.client;

import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;
import com.sun.java.swing.*;

/*
 * ToolBar with Image Button
 */

public class ToolBar extends JToolBar{

  private JButton infoButton, interactButton;
  private Client top;

  private String infoToolTip =
    "the List of the Informations You Received";
  private String interactToolTip =
    "the List of the Interactions You Submitted";

  public ToolBar(Client top) {
    this.top = top;
    URL imageUrl;
    try {
      URL imgPathUrl =
	new URL(top.getDocumentBase(), "../../../../etc/images/");

      String name = top.getParameter("agentName");
      imageUrl = new URL(top.getDocumentBase(), "../images/" + name + ".gif");
      try{
	// check if "name".gif is exits
	// this check is not available on local test.
	int i = imageUrl.openStream().read();
      }catch(FileNotFoundException e){
	System.out.println(imageUrl + " is not found. DefaultFace was selected");
	imageUrl = new URL(imgPathUrl,"./defaultFace.gif");	    
      }catch(Exception e){
	System.out.println(e);
      }
      JButton faceButton;
      faceButton = new JButton(new ImageIcon(imageUrl));
      add(faceButton);

      imageUrl = new URL(imgPathUrl, "./info.gif");
      infoButton = new JButton(new ImageIcon(imageUrl));
      infoButton.addActionListener(new ToolBarAction());
      infoButton.setToolTipText(infoToolTip);
      add(infoButton);

      imageUrl = new URL(imgPathUrl, "./history.gif");
      interactButton = new JButton(new ImageIcon(imageUrl));
      interactButton.addActionListener(new ToolBarAction());
      interactButton.setToolTipText(interactToolTip);
      add(interactButton);

    } catch (MalformedURLException e) {
      Log.error("Malformed URL");
    }
  }

  class ToolBarAction implements ActionListener{
    public void actionPerformed(ActionEvent event){
      if (event.getSource() == infoButton) {
	top.makeInformList();
      }
      if (event.getSource() == interactButton) {
	top.makeInteractList();
      }
    }
  }
  
}



