package ORG.ebiss.sara.interpreter;

import java.io.*;
import java.util.*;
import COM.objectspace.jgl.*;

public class AllAncestorEnumeration implements Enumeration {
  SpdValue	receiver;
  Vector	lookupQueue = new Vector();

  public AllAncestorEnumeration(SpdValue receiver) {
    this.receiver = receiver;
    if (receiver != SpdValue._object) {
      lookupQueue.addElement(SpdValue._object);
    }
    lookupQueue.addElement(receiver);
  }

  public boolean hasMoreElements() {
    return ! lookupQueue.isEmpty();
  }

  public Object nextElement() throws NoSuchElementException {
    if (lookupQueue.isEmpty()) throw new NoSuchElementException();

    SpdValue object = (SpdValue)lookupQueue.lastElement();
    lookupQueue.removeElementAt(lookupQueue.size() - 1);
    for (Enumeration e = object.parents(); e.hasMoreElements(); ) {
      SpdValue parent = (SpdValue)
	((Slot)object._slots.get((String)e.nextElement())).read(receiver);
      lookupQueue.addElement(parent);
    }

    return object;
  }
}
