package ORG.ebiss.sara.interpreter;

import ORG.ebiss.sara.parser.UnaryOpExpression;
import ORG.ebiss.sara.parser.BinaryOpExpression;

/**
 * 
 * 
 * @version	1.0 Oct 1997
 * @author	TOGAWA Atsushi
 */
public final class BooleanValue extends Value implements Atomic {
  public final static BooleanValue	TRUE = new BooleanValue(true);
  public final static BooleanValue	FALSE = new BooleanValue(false);

  private boolean	_value;

  public BooleanValue(boolean value) { _value = value; }

  /*========================================================================
   *	ͤФŪ
   *========================================================================*/

  public boolean equals(Object v) {
    return v != null &&
      v instanceof BooleanValue && ((BooleanValue)v)._value == _value;
  }

  public int hashCode() { return _value ? 1231 : 1237; }

  public boolean equalsToLabel(Object v) {
    if (! (v instanceof Boolean)) return false;
    return ((Boolean)v).booleanValue() == _value;
  }

  /*========================================================================
   *		黻
   *========================================================================*/

  public Value binaryOp(int opcode, Value operand)
       throws InvalidOperationException, CoerceFailedException
  {
    switch(opcode) {

    case BinaryOpExpression.EQUAL:
      return _value == operand.booleanValue() ? TRUE : FALSE;

    case BinaryOpExpression.NOT_EQUAL:
      return _value != operand.booleanValue() ? TRUE : FALSE;

    default:
      throw new InvalidOperationException();
    }
  }

  public Value unaryOp(int opcode) throws InvalidOperationException {
    switch(opcode) {
    case UnaryOpExpression.CONDITIONAL_NOT:
      return _value ? FALSE : TRUE;

    default:
      throw new InvalidOperationException();
    }
  }

  /*========================================================================
   *	¾ΥǡؤѴ뤤¾ΥǡѴ
   *========================================================================*/

  public boolean booleanValue() { return _value; }

  public String stringValue() { return _value ? "true" : "false"; }

  public Object javaValue() {
    return _value ? Boolean.TRUE : Boolean.FALSE;
  }

  public Class javaClass() { return Boolean.TYPE; }

  /*========================================================================
   *	ɽǽʸɽؤѴ
   *========================================================================*/

  public String getPrintableRepresentation() {
    return _value ? "true" : "false";
  }

  public Object getPrintableRepresentation(PrintingContext context) {
    return getPrintableRepresentation();
  }
}
