package ORG.ebiss.sara.interpreter;

import java.util.*;
import COM.objectspace.jgl.*;

public abstract class ContainerValue extends JavaValue {

  public ContainerValue(Object javaValue) { super(javaValue); }

  public abstract Container createContainer();

  public int size() { return ((Container)_object).size(); }

  public Enumeration elements() { return ((Container)_object).elements(); }

  public void add(Value x) { ((Container)_object).add(x); }

  public Value at(int index) { return (Value)((Sequence)_object).at(index); }

  /*========================================================================
   *	ͤФŪ
   *========================================================================*/

  public Value copy() {
    try {
      return super.copy();
    } catch (InvalidOperationException use) {
      throw new RuntimeException();
    }
  }

  protected Object copyObject() {
    return ((Container)_object).clone();
  }

  /*========================================================================
   *		黻
   *========================================================================*/

  public Value binaryOp(int opcode, Value operand)
       throws InvalidOperationException, CoerceFailedException
  {
    if (! (operand instanceof JavaValue)) {
      return super.binaryOp(opcode, operand);
    }
    Object rterm = ((JavaValue)operand).getJavaValue();
    switch (opcode) {

    case ORG.ebiss.sara.parser.BinaryOpExpression.PLUS:
      if (rterm instanceof Container) {
	ContainerValue result = (ContainerValue)copy();
	Container container = (Container)result._object;
	for (ForwardIterator e = ((Container)rterm).start();
	     e.hasMoreElements(); ) {
	  container.add(e.nextElement());
	}
	return result;

      }
      return super.binaryOp(opcode, operand);

    default:
      return super.binaryOp(opcode, operand);
    }
  }

  /*========================================================================
   *	¾ΥǡؤѴ뤤¾ΥǡѴ
   *========================================================================*/

  public String stringValue() throws CoerceFailedException {
    return toString();
  }

  /*========================================================================
   *	ɽǽʸɽؤѴ
   *========================================================================*/

  protected DelayedPrinting createDelayedPrinting() {
    String name = _object.getClass().getName();
    String prefix = name.substring(name.lastIndexOf('.') + 1) + "(";
    return new Printing(this, prefix, ")");
  }

  protected static class Printing extends DelayedPrinting {
    private String	_prefix;
    private String	_suffix;
    private Vector	_elements = new Vector();

    public Printing(ContainerValue value, String prefix, String suffix) {
      super(value);
      _prefix = prefix;
      _suffix = suffix;
    }

    public String getPrintableRepresentation() {
      StringBuffer result = new StringBuffer(_prefix);
      boolean needSeparator = false;
      for (Enumeration e = _elements.elements(); e.hasMoreElements(); ) {
	if (needSeparator) result.append(", ");
	else needSeparator = true;
	result.append(e.nextElement());
      }
      result.append(_suffix);
      return result.toString();
    }

    public void fillContents(PrintingContext context) {
      for (ForwardIterator e =
	     ((Container)((ContainerValue)_value)._object).start();
	   e.hasMoreElements(); ) {
	Value value = (Value)e.nextElement();
	_elements.addElement(value.getPrintableRepresentation(context));
      }
    }
  }
}
