package ORG.ebiss.sara.interpreter;

import java.util.*;
import ORG.ebiss.sara.parser.*;

/**
 * ټ¿
 * 
 * @version	1.0 Oct 1997
 * @author	TOGAWA Atsushi
 */
public final class DoubleValue extends Value implements Atomic {
  private double	_value;

  public DoubleValue(double value) { _value = value; }

  /*========================================================================
   *	ͤФŪ
   *========================================================================*/

  public boolean equals(Object v) {
    return v != null &&
      v instanceof DoubleValue && ((DoubleValue)v)._value == _value;
  }

  public int hashCode() {
    long bits = Double.doubleToLongBits(_value);
    return (int)(bits ^ (bits >> 32));
  }

  public boolean equalsToLabel(Object v) {
    if (! (v instanceof Double)) return false;
    return ((Double)v).doubleValue() == _value;
  }

  /*========================================================================
   *		黻
   *========================================================================*/

  public Value binaryOp(int opcode, Value operand)
       throws InvalidOperationException, CoerceFailedException
  {
    switch(opcode) {
    case BinaryOpExpression.MULTIPLY:
      return new DoubleValue(_value * operand.doubleValue());
    case BinaryOpExpression.DIVIDE:
      return new DoubleValue(_value / operand.doubleValue());
    case BinaryOpExpression.REMAINDER:
      return new DoubleValue(Math.IEEEremainder(_value,
						operand.doubleValue()));
    case BinaryOpExpression.PLUS:
      return new DoubleValue(_value + operand.doubleValue());
    case BinaryOpExpression.MINUS:
      return new DoubleValue(_value - operand.doubleValue());
    case BinaryOpExpression.LESS:
      return _value < operand.doubleValue()
	? BooleanValue.TRUE : BooleanValue.FALSE;
    case BinaryOpExpression.GREATER:
      return _value > operand.doubleValue()
	? BooleanValue.TRUE : BooleanValue.FALSE;
    case BinaryOpExpression.LESS_EQUAL:
      return _value <= operand.doubleValue()
	? BooleanValue.TRUE : BooleanValue.FALSE;
    case BinaryOpExpression.GREATER_EQUAL:
      return _value >= operand.doubleValue()
	? BooleanValue.TRUE : BooleanValue.FALSE;

    default:
      return super.binaryOp(opcode, operand);
    }
  }

  public Value unaryOp(int opcode) throws InvalidOperationException {
    switch(opcode) {
    case UnaryOpExpression.PLUS:
      return this;
    case UnaryOpExpression.MINUS:
      return new DoubleValue(-_value);

    default:
      throw new InvalidOperationException();
    }
  }

  /*========================================================================
   *	¾ΥǡؤѴ뤤¾ΥǡѴ
   *========================================================================*/

  public double doubleValue() { return _value; }

  public String stringValue() { return Double.toString(_value); }

  public Object javaValue() { return new Double(_value); }

  public Class javaClass() { return Double.TYPE; }

  /*========================================================================
   *	ɽǽʸɽؤѴ
   *========================================================================*/

  public Object getPrintableRepresentation(PrintingContext context) {
    return Double.toString(_value);
  }
}
