package ORG.ebiss.sara.interpreter;

import COM.objectspace.jgl.*;

public class FunctionAdapter implements UnaryFunction, BinaryFunction {
  private Interpreter		_interpreter;
  private ApplicableValue	_adaptee;
  private Value[]		unaryArgument = new Value[1];
  private Value[]		binaryArgument = new Value[2];

  public FunctionAdapter(Interpreter interpreter, ApplicableValue adaptee) {
    _interpreter = interpreter;
    _adaptee = adaptee;
  }

  public Object execute(Object x) {
    unaryArgument[0] = x instanceof Value ? (Value)x : new JavaValue(x);
    try {
      return _interpreter.evaluate(_adaptee, unaryArgument);
    } catch (EvaluationException ee) {
      ee.printStackTrace();
      throw new RuntimeException();
    }
  }

  public Object execute(Object x, Object y) {
    binaryArgument[0] = x instanceof Value ? (Value)x : new JavaValue(x);
    binaryArgument[1] = y instanceof Value ? (Value)y : new JavaValue(y);
    try {
      return _interpreter.evaluate(_adaptee, binaryArgument);
    } catch (EvaluationException ee) {
      ee.printStackTrace();
      throw new RuntimeException();
    }
  }
}
