package ORG.ebiss.sara.interpreter;

import java.io.*;
import java.util.*;
import COM.objectspace.jgl.*;

public class MethodSlot extends Slot {
  protected Method[]	_methods;

  public MethodSlot(SpdValue container, String[] modifiers,
		    String name, Method[] methods) {
    super(container, modifiers, name);
    _methods = methods;
  }

  public Slot copy(SpdValue destination) {
    try {
      return destination.createMethodSlot(_modifiers, _name, _methods);
    } catch (InvalidOperationException uoe) {
      uoe.printStackTrace();
      throw new RuntimeException();
    }
  }

  public Object getPrintableRepresentation(final PrintingContext context) {
    return new Object() {
      public String toString() {
	StringBuffer buffer = new StringBuffer();
	for (Enumeration i = modifiers(); i.hasMoreElements(); ) {
	  buffer.append(i.nextElement());
	  buffer.append(' ');
	}
	buffer.append(name());
	for (int i = 0; i < _methods.length; ++i) {
	  if (i > 0) buffer.append("| ");
	  buffer.append(_methods[i].getPrintableRepresentation(context));
	}
	buffer.append(";");
	return buffer.toString();
      }
    };
  }

  public Value read(SpdValue receiver) {
    SlotEnumeration superSlots = new SlotEnumeration(receiver, name());
    while (superSlots.nextElement() != this) ;
    return new MethodValue(getContainer(), receiver, superSlots, _methods);
  }

  public void write(SpdValue receiver, Value value)
       throws InvalidOperationException
  {
    if (! (value instanceof MethodValue)) {
      super.write(receiver, value);
      return;
    }
    _methods = (Method[])((MethodValue)value).firstMethods.clone();
  }
}
