package ORG.ebiss.sara.interpreter;

import java.io.*;
import java.util.*;
import COM.objectspace.jgl.*;

class MethodValue extends ApplicableValue {
  public SpdValue		container;
  public SpdValue		receiver;
  public Method[]		firstMethods;
  public SlotEnumeration	slots;

  public MethodValue(SpdValue container, SpdValue receiver,
		     SlotEnumeration slots, Method[] firstMethods)
  {
    this.container = container;
    this.receiver = receiver;
    this.slots = slots;
    this.firstMethods = firstMethods;
  }

  public Code apply(Interpreter interpreter,
		    int[] arguments, int resultSlot, Code returnPoint)
  {
    Code lookup = new NextMethod(interpreter.currentNode(),
				 container, receiver,
				 firstMethods, slots);
    interpreter.pushFrame(arguments, resultSlot, returnPoint, lookup);
    return lookup;
  }

  public boolean checkArity(int arity) {
    for (int i = 0; i < firstMethods.length; ++i) {
      if (firstMethods[i].checkArity(arity)) return true;
    }
    for (Enumeration e = (Enumeration)(slots.clone()); e.hasMoreElements(); ) {
      Slot slot = (Slot)e.nextElement();
      if (! (slot instanceof MethodSlot)) continue;
      Method methods[] = ((MethodSlot)slot)._methods;
      for (int i = 0; i < methods.length; ++i) {
	if (methods[i].checkArity(arity)) return true;
      }
    }
    return false;
  }
}
