package ORG.ebiss.sara.interpreter;

import java.io.*;
import java.util.*;
import COM.objectspace.jgl.*;

class NextMethod extends Code {
  private int		index;
  private Method[]	methods;
  private Enumeration	SlotEnumeration;
  protected SpdValue	container;
  protected SpdValue	receiver;

  public NextMethod(ORG.ebiss.sara.parser.Node x,
		    SpdValue container, SpdValue receiver,
		    Method[] firstMethods, Enumeration SlotEnumeration)
  {
    super(x);
    this.container = container;
    this.receiver = receiver;
    methods = firstMethods;
    this.SlotEnumeration =
      (SlotEnumeration)((SlotEnumeration)SlotEnumeration).clone();
  }

  public boolean hasMoreMethods() {
    if (index < methods.length) return true;
    while (index >= methods.length) {
      if (! SlotEnumeration.hasMoreElements()) return false;
      Slot slot = (Slot)SlotEnumeration.nextElement();
      if (! (slot instanceof MethodSlot)) continue;
      index = 0;
      methods = ((MethodSlot)slot)._methods;
      container = slot.getContainer();
    }
    return true;
  }

  public Code execute(Interpreter interpreter) throws EvaluationException {
    if (! hasMoreMethods()) noMatchingMethod();
    interpreter.resetNameSpace();
    Method method = methods[index++];
    return method.apply(interpreter, container, receiver);
  }
}
