package ORG.ebiss.sara.interpreter;

import java.util.*;
import ORG.ebiss.sara.parser.BinaryOpExpression;

public abstract class PrimitiveMethod implements Method {
  private int		_arity;

  public PrimitiveMethod(int arity) { _arity = arity; }

  public Code apply(Interpreter interpreter,
		    SpdValue container, SpdValue receiver)
       throws EvaluationException
  {
    return apply(interpreter, receiver);
  }

  public Code apply(Interpreter interpreter, SpdValue receiver)
       throws EvaluationException
  {
    if (interpreter.arity() != _arity) return null;
    return execute(interpreter, receiver);
  }

  protected abstract
  Code execute(Interpreter interpreter, SpdValue receiver)
       throws EvaluationException;

  public Object getPrintableRepresentation(PrintingContext context) {
    StringBuffer result = new StringBuffer("(");
    for (int i = 0; i < _arity; ++i) {
      result.append(i > 0 ? ",*" : "*");
    }
    result.append(")");
    return result.toString();
  }

  public boolean checkArity(int arity) { return arity == _arity; }
}
