package ORG.ebiss.sara.interpreter;

import java.io.*;
import java.util.*;
import COM.objectspace.jgl.*;

public abstract class Slot implements Cloneable, Serializable {
  protected String	_name;
  protected String[]	_modifiers;
  SpdValue		_container;

  protected Slot(SpdValue container, String[] modifiers, String name) {
    _container = container;
    _name = name;
    _modifiers = modifiers;
  }

  public String name() { return _name; }

  public SpdValue getContainer() { return _container; }

  public Enumeration modifiers() {
    return new ObjectIterator(_modifiers, 0);
  }

  public boolean hasModifier(String modifier) {
    for (int i = 0; i < _modifiers.length; ++i) {
      if (_modifiers[i].equals(modifier)) return true;
    }
    return false;
  }

  public void enter(SpdValue object) {}

  public void leave(SpdValue object) {}

  public abstract Slot copy(SpdValue destination);

  public Slot freshCopy(SpdValue destination) {
    return copy(destination);
  }

  public Object getPrintableRepresentation(PrintingContext context) {
    return "<unknown slot: " + _name + ">";
  }

  public abstract Value read(SpdValue receiver);

  public void write(SpdValue receiver, Value value)
       throws InvalidOperationException
  {
    throw new InvalidOperationException();
  }
}
