package ORG.ebiss.sara.interpreter;

import java.io.*;
import java.util.*;
import COM.objectspace.jgl.*;

/**
 *
 * XXX
 * ʣparentåȤƱΥ֥Ȥ򤵤θɬפ.
 * ޤѾط˥뤬ȯƤʤɬפ
 * 
 * @version	1.0 Sep 1997
 * @author	TOGAWA Atsushi
 */
public class SpdValue extends Value {
  public final static String[]	noModifiers = {};
  public final static String[]	inheritModifier = { "inherit" };

  HashMap 	_slots = new HashMap(new EqualTo(), false, 19, 0.75f);
  Array   	_parents = new Array();
  Hashtable	snapshot = null;

  public static SpdValue	_object;

  public Value copy() {
    try {
      SpdValue result = (SpdValue)clone();
      result.copy(this);
      return result;
    } catch (CloneNotSupportedException cnse) {
      cnse.printStackTrace();
      throw new RuntimeException();
    }
  }

  public SpdValue freshCopy() {
    try {
      SpdValue result = (SpdValue)clone();
      result.freshCopy(this);
      return result;
    } catch (CloneNotSupportedException cnse) {
      cnse.printStackTrace();
      throw new RuntimeException();
    }
  }

  public void copy(SpdValue value) {
    _parents = new Array();
    _slots = (HashMap)value._slots.clone();
    for (HashMapIterator i = _slots.begin(); !i.atEnd(); i.advance()) {
      Slot slot = ((Slot)i.value()).copy(this);
      i.value(slot);
      slot.enter(this);
    }
  }

  public void freshCopy(SpdValue value) {
    _parents = new Array();
    _slots = (HashMap)value._slots.clone();
    for (HashMapIterator i = _slots.begin(); !i.atEnd(); i.advance()) {
      Slot slot = ((Slot)i.value()).copy(this);
      i.value(slot);
      slot.enter(this);
    }
  }

  public void addSlot(Slot slot) throws InvalidOperationException {
    Slot oldSlot = (Slot)_slots.put(slot.name(), slot);
    if (oldSlot != null) oldSlot.leave(this);
    slot.enter(this);
  }

  public void removeSlot(String name) {
    Slot slot = (Slot)_slots.remove(name);
    if (slot != null) slot.leave(this);
  }

  public void addParent(String parent) { _parents.add(parent); }

  public void removeParent(String parent) { _parents.remove(parent, 1); }

  public Enumeration parents() { return _parents.elements(); }

  public void defineVariable(String[] modifiers, String name, Value value)
       throws InvalidOperationException
  {
    addSlot(createDataSlot(modifiers, name, value));
  }

  public void defineVariable(String name, Value value)
       throws InvalidOperationException
  {
    addSlot(createDataSlot(noModifiers, name, value));
  }

  public void defineMethod(String[] modifiers, String name, Method[] methods)
       throws InvalidOperationException
  {
    addSlot(createMethodSlot(modifiers, name, methods));
  }

  public void defineMethod(String name, Method method)
       throws InvalidOperationException
  {
    Method[] methods = new Method[1];
    methods[0] = method;
    addSlot(createMethodSlot(noModifiers, name, methods));
  }

  public Enumeration elements() { return _slots.keys(); }

  public Enumeration slots() { return _slots.elements(); }

  public Enumeration ancestors() { return new AllAncestorEnumeration(this); }

  public boolean inherits(SpdValue value) {
    Vector queue = new Vector();
    if (this != _object) {
      queue.addElement(_object);
    }
    queue.addElement(this);
    while (! queue.isEmpty()) {
      SpdValue head = (SpdValue)queue.lastElement();
      if (head == value) return true;
      queue.removeElementAt(queue.size() - 1);
      for (Enumeration e = head.parents(); e.hasMoreElements(); ) {
	SpdValue parent = (SpdValue)
	  ((Slot)head._slots.get((String)e.nextElement())).read(head);
	queue.addElement(parent);
      }
    }
    return false;
  }

  public void join(SpdValue value) throws InvalidOperationException {
    for (Enumeration e = value._slots.elements(); e.hasMoreElements(); ) {
      Slot slot = (Slot)e.nextElement();
      addSlot(slot.copy(this));
    }
  }

  static class Copy extends ExpressionCode {
    public SpdValue	object;

    Copy(ORG.ebiss.sara.parser.Node x) { super(x); }

    public Code execute(Interpreter interpreter) throws EvaluationException {
      int[] args = new int[0];
      Value copy = object.read("copy");
      if (! (copy instanceof ApplicableValue)) noMatchingMethod("copy");
      return ((ApplicableValue)copy).apply(interpreter, args, slot, successor);
    }
  }

  static class Join extends ExpressionCode {
    public int	object;
    public int	operand;

    Join(ORG.ebiss.sara.parser.Node x) { super(x); }

    public Code execute(Interpreter interpreter) throws EvaluationException {
      int[] args = new int[1];
      args[0] = operand;
      Value join = interpreter.readRegister(object).read("join");
      if (! (join instanceof ApplicableValue)) noMatchingMethod("join");
      return ((ApplicableValue)join).apply(interpreter, args, slot, successor);
    }
  }

  public Code binaryOp(Interpreter interpreter, int opcode,
		       int operand, int resultSlot, Code successor)
       throws InvalidOperationException, CoerceFailedException
  {
    Value rterm = interpreter.readRegister(operand);
    if (opcode == ORG.ebiss.sara.parser.BinaryOpExpression.PLUS &&
	rterm instanceof SpdValue) {
      ORG.ebiss.sara.parser.Node node = interpreter.currentNode();
      Copy copy = new Copy(node);
      Join join = new Join(node);
      copy.object = this;
      copy.slot = resultSlot;
      copy.successor = join;
      join.object = resultSlot;
      join.operand = operand;
      join.slot = resultSlot;
      join.successor = successor;
      return copy;
    }
    return super.binaryOp(interpreter, opcode, operand, resultSlot, successor);
  }

  protected DelayedPrinting createDelayedPrinting() {
    return new Printing(this);
  }

  protected static class Printing extends DelayedPrinting {
    public Vector elementPrintings = new Vector();

    public Printing(SpdValue value) { super(value); }

    public String getPrintableRepresentation() {
      StringBuffer result = new StringBuffer("{");
      for (Enumeration e = elementPrintings.elements();
	   e.hasMoreElements(); ) {
	result.append(e.nextElement());
	result.append(' ');
      }
      result.append("}");
      return result.toString();
    }

    public void fillContents(PrintingContext context) {
      for (Enumeration e = ((SpdValue)_value)._slots.elements();
	   e.hasMoreElements(); ) {
	Slot slot = (Slot)e.nextElement();
	elementPrintings.addElement(slot.getPrintableRepresentation(context));
      }
    }
  }

  public Enumeration lookup(String name) {
    return new SlotEnumeration(this, name);
  }

  public Slot lookupSlot(String name) {
    Enumeration e = new SlotEnumeration(this, name);
    if (e.hasMoreElements()) return (Slot)e.nextElement();
    return null;
  }

  public Value read(String name) {
    if (name.equals("this")) return this;
    Slot slot = (Slot)_slots.get(name);
    if (slot != null) return slot.read(this);
    Enumeration e = lookup(name);
    if (e.hasMoreElements()) return ((Slot)e.nextElement()).read(this);
    return null;
  }

  public Value readSuper(String name, SpdValue receiver) {
    SlotEnumeration e = (SlotEnumeration)lookup(name);
    e.skip();
    if (! e.hasMoreElements()) return null;
    return ((Slot)e.nextElement()).read(receiver);
  }

  public boolean write(String name, Value value)
       throws InvalidOperationException
  {
    Slot slot = (Slot)_slots.get(name);
    if (slot != null) {
      slot.write(this, value);
      return true;
    }
    SlotEnumeration e = new SlotEnumeration(this, name);
    if (e.hasMoreElements()) {
      ((Slot)e.nextElement()).write(this, value);
      return true;
    }
    return false;
  }

  public boolean contains(String name) {
    if (_slots.get(name) != null) return true;
    Enumeration e = lookup(name);
    return e.hasMoreElements();
  }

  public boolean isAction(String name) {
    Slot slot = lookupSlot(name);
    if (slot == null) {
      throw new RuntimeException("Unknown slot: " + name);
    }
    return slot instanceof ActionSlot;
  }

  public boolean isVisible(String name) {
    Slot slot = lookupSlot(name);
    if (slot == null) {
      throw new RuntimeException("Unknown slot: " + name);
    }
    return slot instanceof ObservableSlot && ((ObservableSlot)slot).visible();
  }

  public void setVisible(String name, boolean value) {
    Slot slot = (Slot)lookupSlot(name);
    if (slot == null) {
      throw new RuntimeException("Unknown slot: " + name);
    }
    if (! (slot instanceof ObservableSlot)) {
      throw new RuntimeException(name + " is not an action or a property");
    }
    ((ObservableSlot)slot).visible(value);
  }

  public String getLabel(String name) {
    Slot slot = lookupSlot(name);
    if (slot == null) {
      throw new RuntimeException("Unknown slot: " + name);
    }
    if (! (slot instanceof ObservableSlot)) {
      throw new RuntimeException(name + " is not an action or a property");
    }
    return ((ObservableSlot)slot).label();
  }

  public void setLabel(String name, String label) {
    Slot slot = lookupSlot(name);
    if (slot == null) {
      throw new RuntimeException("Unknown slot: " + name);
    }
    if (! (slot instanceof ObservableSlot)) {
      throw new RuntimeException(name + " is not an action or a property");
    }
    ((ObservableSlot)slot).label(label);
  }

  protected Slot createDataSlot(String[] modifiers, String name, Value value)
       throws InvalidOperationException
  {
    for (int i = 0; i < modifiers.length; ++i) {
      if (modifiers[i].equals("property")) {
	return new PropertySlot(this, modifiers, name, value);
      }
    }
    return new DataSlot(this, modifiers, name, value);
  }

  protected Slot createMethodSlot(String[] modifiers,
				  String name, Method[] methods)
       throws InvalidOperationException
  {
    for (int i = 0; i < modifiers.length; ++i) {
      if (modifiers[i].equals("action")) {
	return new ActionSlot(this, modifiers, name, methods);
      }
    }
    return new MethodSlot(this, modifiers, name, methods);
  }

  public void importSlot(String name, SpdValue object, String slotName)
       throws InvalidOperationException
  {
    addSlot(new ImportedSlot(this, name, object, object.lookupSlot(slotName)));
  }

  public void getChangeList(Array addList,
			    Array removeList, Array modifiedList)
       throws InvalidOperationException
  {
    addList.clear();
    removeList.clear();
    modifiedList.clear();

    if (snapshot == null) snapshot = new Hashtable();

    for (Enumeration e = snapshot.elements(); e.hasMoreElements(); ) {
      SlotMemo memo = (SlotMemo)e.nextElement();
      Slot value = lookupSlot(memo.name);
      if (value == null || !(value instanceof ObservableSlot)) {
	removeList.add(new StringValue(memo.name));
	continue;
      }

      boolean changed = false;
      if (((ObservableSlot)value).visible() != memo.visible) {
	changed = true;
	memo.visible = ((ObservableSlot)value).visible();
      }
      if (! ((ObservableSlot)value).label().equals(memo.label)) {
	changed = true;
	memo.label = ((ObservableSlot)value).label();
      }

      Slot master = value instanceof ImportedSlot
		      ? ((ImportedSlot)value).getMaster()
		      : value;
      if (master instanceof DataSlot && memo instanceof PropertyMemo) {
	if (! value.read(this).equals(((PropertyMemo)memo).value)) {
	  changed = true;
	  ((PropertyMemo)memo).setValue(value.read(this));
	}
      } else if (master instanceof DataSlot != memo instanceof PropertyMemo) {
        SlotMemo newMemo;
	changed = true;
	if (master instanceof DataSlot) {
	  newMemo = new PropertyMemo();
	  ((PropertyMemo)newMemo).setValue(master.read(this));
	} else {
	  newMemo = new SlotMemo();
	}
	newMemo.visible = memo.visible;
	newMemo.label = memo.label;
      }

      if (changed) modifiedList.add(new StringValue(memo.name));
    }

    for (Enumeration e = removeList.elements(); e.hasMoreElements(); ) {
      snapshot.remove(e.nextElement().toString());
    }

    for (Enumeration e = ancestors(); e.hasMoreElements(); ) {
      SpdValue object = (SpdValue)e.nextElement();
      for (Enumeration f = object.slots(); f.hasMoreElements(); ) {
	Slot slot = (Slot)f.nextElement();
	String name = slot.name();
	if (! (slot instanceof ObservableSlot) || snapshot.get(name) != null) {
	  continue;
	}

	SlotMemo newMemo;
	if (slot instanceof DataSlot) {
	  newMemo = new PropertyMemo();
	  ((PropertyMemo)newMemo).setValue(slot.read(this));
	} else {
	  newMemo = new SlotMemo();
	}

	newMemo.name = slot.name();
	newMemo.visible = ((ObservableSlot)slot).visible();
	newMemo.label = ((ObservableSlot)slot).label();
	snapshot.put(newMemo.name, newMemo);

	addList.add(new StringValue(newMemo.name));
      }
    }
  }
}

class SlotMemo {
  public String		name;
  public boolean	visible;
  public String		label;
}

class PropertyMemo extends SlotMemo {
  public Value		value;

  void setValue(Value value) throws InvalidOperationException {
    if (value instanceof Atomic) {
      this.value = value;
    } else if (value instanceof ContainerValue) {
      Container container = ((Container)((JavaValue)value).getJavaValue());
      for (ForwardIterator i = container.start(); i.hasMoreElements(); ) {
	Object item = i.nextElement();
	if (item instanceof Pair) {
	  Pair p = (Pair)item;
	  if (! (p.first instanceof Atomic && p.second instanceof Atomic)) {
	    throw new InvalidOperationException("elements must be atomic");
	  }
	} else if (! (item instanceof Atomic)) {
	  throw new InvalidOperationException("elements must be atomic");
	}
      }
      this.value = value.copy();
    } else {
      throw new InvalidOperationException("atomic or flat container only");
    }
  }
}
