package ORG.ebiss.sara.interpreter;

import java.util.*;
import ORG.ebiss.sara.parser.*;

/**
 * ʸ
 * 
 * @version	1.0 Oct 1997
 * @author	TOGAWA Atsushi
 */
public final class StringValue extends Value implements Atomic {
  private String	_value;

  public StringValue(String value) { _value = value; }

  /*========================================================================
   *	ͤФŪ
   *========================================================================*/

  public boolean equals(Object v) {
    return v != null &&
      v instanceof StringValue && ((StringValue)v)._value.equals(_value);
  }

  public String toString() {
    return _value;
  }

  public int hashCode() { return _value.hashCode(); }

  public boolean equalsToLabel(Object v) {
    if (! (v instanceof String)) return false;
    return ((String)v).equals(_value);
  }

  /*========================================================================
   *		黻
   *========================================================================*/

  public Value binaryOp(int opcode, Value operand)
       throws InvalidOperationException, CoerceFailedException
  {
    switch(opcode) {

    case BinaryOpExpression.PLUS:
      return new StringValue(_value + operand.stringValue());

    case BinaryOpExpression.LESS:
      return _value.compareTo(operand.stringValue()) < 0
	? BooleanValue.TRUE : BooleanValue.FALSE;

    case BinaryOpExpression.GREATER:
      return _value.compareTo(operand.stringValue()) > 0
	? BooleanValue.TRUE : BooleanValue.FALSE;

    case BinaryOpExpression.LESS_EQUAL:
      return _value.compareTo(operand.stringValue()) <= 0
	? BooleanValue.TRUE : BooleanValue.FALSE;

    case BinaryOpExpression.GREATER_EQUAL:
      return _value.compareTo(operand.stringValue()) >= 0
	? BooleanValue.TRUE : BooleanValue.FALSE;

    default:
      return super.binaryOp(opcode, operand);
    }
  }

  /*========================================================================
   *	¾ΥǡؤѴ뤤¾ΥǡѴ
   *========================================================================*/

  public int intValue() throws CoerceFailedException {
    try {
      return Integer.parseInt(_value);
    } catch (NumberFormatException nfe) {
      throw new CoerceFailedException();
    }
  }

  public double doubleValue() throws CoerceFailedException {
    try {
      return Double.valueOf(_value).doubleValue();
    } catch (NumberFormatException nfe) {
      throw new CoerceFailedException();
    }
  }

  public boolean booleanValue() throws CoerceFailedException {
    if (_value.equals("true")) return true;
    if (_value.equals("false")) return false;
    throw new CoerceFailedException();
  }

  public String stringValue() { return _value; }

  public Object javaValue() { return _value; }

  private final static Class _stringClass = "".getClass();

  public Class javaClass() { return _stringClass; }

  /*========================================================================
   *	ɽǽʸɽؤѴ
   *========================================================================*/

  public Object getPrintableRepresentation(PrintingContext context) {
    return "\"" + _value + "\"";
  }
}
