package ORG.ebiss.sara.interpreter;

import java.util.*;
import ORG.ebiss.sara.parser.*;

public final class SymbolValue extends Value implements Atomic {
  private static Hashtable _symbolTable = new Hashtable();

  public static SymbolValue intern(String name) {
    SymbolValue result = (SymbolValue)_symbolTable.get(name);
    if (result == null) {
      result = new SymbolValue(name);
      _symbolTable.put(name, result);
    }
    return result;
  }

  private String	_name;

  public String name() { return _name; }

  private SymbolValue(String name) { _name = name; }

  public String stringValue() { return _name; }

  public Object javaValue() { return _name; }

  public Class javaClass() { return "".getClass(); }

  /**
   * ֥ȤͿ줿ƥͤȹפ뤫ɤ򸡺.
   * ƥͤ, <code>Integer</code>, <code>String</code>,
   * <code>Boolean</code>, <code>Double</code>, <code>Symbol</code>饹
   * 줫Υ󥹥󥹤Ǥ롥
   * @param label	٥. 
   * @return		פ<code>true</code>
   */
  public boolean equalsToLabel(Object label) {
    return label != null && label instanceof Symbol &&
      ((Symbol)label).name().equals(_name);
  }

  public Object getPrintableRepresentation(PrintingContext context) {
    return "`" + _name;
  }
}
