package ORG.ebiss.sara.interpreter;

import java.io.*;
import java.util.*;
import ORG.ebiss.sara.parser.Symbol;
import COM.objectspace.jgl.*;

public class Value implements Cloneable, Serializable, NameSpace {
  public final static Value UNSPECIFIED = new Value();
  public final static Value NULL = new Value();

  public String toString() {
    return getPrintableRepresentation();
  }

  /*========================================================================
   *	ͤФŪ
   *========================================================================*/

  public Value copy() throws InvalidOperationException {
    try {
      return (Value)clone();
    } catch (CloneNotSupportedException cnse) {
      cnse.printStackTrace();
      throw new RuntimeException(cnse.getMessage());
    }
  }

  /**
   * ֥ȤͿ줿ƥͤȹפ뤫ɤ򸡺.
   * ƥͤ, <code>Integer</code>, <code>String</code>,
   * <code>Boolean</code>, <code>Double</code>, <code>Symbol</code>饹
   * 줫Υ󥹥󥹤Ǥ롥
   * @param label	٥. 
   * @return		פ<code>true</code>
   */
  public boolean equalsToLabel(Object label) { return false; }

  /*========================================================================
   *		黻
   *========================================================================*/

  public Code binaryOp(Interpreter interpreter, int opcode,
		       int operand, int resultSlot, Code successor)
       throws InvalidOperationException, CoerceFailedException
  {
    Value result = binaryOp(opcode, interpreter.readRegister(operand));
    interpreter.writeRegister(resultSlot, result);
    return successor;
  }

  public Value binaryOp(int opcode, Value operand)
       throws InvalidOperationException, CoerceFailedException
  {
    if (this == UNSPECIFIED) throw new InvalidOperationException();
    switch (opcode) {
    case ORG.ebiss.sara.parser.BinaryOpExpression.EQUAL:
      return equals(operand) ? BooleanValue.TRUE : BooleanValue.FALSE;
    case ORG.ebiss.sara.parser.BinaryOpExpression.NOT_EQUAL:
      return equals(operand) ? BooleanValue.FALSE : BooleanValue.TRUE;
    default:
      throw new InvalidOperationException();
    }
  }

  public Code unaryOp(Interpreter interpreter, int opcode,
		      int resultSlot, Code successor)
       throws InvalidOperationException, CoerceFailedException
  {
    Value result = unaryOp(opcode);
    interpreter.writeRegister(resultSlot, result);
    return successor;
  }

  public Value unaryOp(int opcode)
       throws InvalidOperationException, CoerceFailedException
  {
    if (this == UNSPECIFIED) throw new InvalidOperationException();
    switch (opcode) {
    default:
      throw new InvalidOperationException();
    }
  }

  /*========================================================================
   *	¾ΥǡؤѴ뤤¾ΥǡѴ
   *========================================================================*/

  public int intValue() throws CoerceFailedException {
    throw new CoerceFailedException();
  }

  public double doubleValue() throws CoerceFailedException {
    throw new CoerceFailedException();
  }

  public boolean booleanValue() throws CoerceFailedException {
    throw new CoerceFailedException();
  }

  public String stringValue() throws CoerceFailedException {
    throw new CoerceFailedException();
  }

  public Object javaValue() {
    if (this == NULL) return null;
    return this;
  }

  public Class javaClass() { return getClass(); }

  /*========================================================================
   *	ɽǽʸɽؤѴ
   *========================================================================*/

  public String getPrintableRepresentation() {
    PrintingContext context = new PrintingContext();
    return getPrintableRepresentation(context).toString();
  }

  protected Object
  getPrintableRepresentation(PrintingContext context) {
    if (this == UNSPECIFIED) return "<unspecified>";
    if (this == NULL) return "<null>";
    DelayedPrinting printing = context.reference(this);
    if (printing != null) return printing;
    return context.delay(this, createDelayedPrinting());
  }

  protected DelayedPrinting createDelayedPrinting() {
    return new DelayedPrinting(this);
  }

  /*========================================================================
   *	֤̾ȤƤ
   *========================================================================*/

  public Value read(String name) {
    return null;
  }

  public boolean write(String name, Value value)
       throws InvalidOperationException
  {
    throw new InvalidOperationException();
  }

  public void define(String name, Value value)
       throws InvalidOperationException
  {
    throw new InvalidOperationException();
  }

  public boolean contains(String name) {
    return false;
  }
}
