package ORG.ebiss.sara.parser;

import java.lang.reflect.*;

/**
 * ʸ
 * 
 * @version	1.0 Sep 1997
 * @author	TOGAWA Atsushi
 */
public abstract class Node {

  /*
   * nullʤХȥ꡼फϤƥȤʸϤȤ򼨤
   */
  private String	_fileName;

  private int		_beginLine, _beginColumn;
  private int		_endLine, _endColumn;

  /**
   * ץΥե̾
   * 
   * @return	ե̾.
   *		⤷ե뤫ɤ߹ޤ줿ΤǤʤ<code>null</code>
   */
  public String fileName() { return _fileName; }

  /**
   * ʸϤޤ
   *
   * @return ֹ
   */
  public int beginLine() { return _beginLine; }

  /**
   * ʸϤޤ
   *
   * @return ֹ
   */
  public int beginColumn() { return _beginColumn; }

  /**
   * ʸ
   *
   * @return ֹ
   */
  public int endLine() { return _endLine; }

  /**
   * ʸ
   * 
   * @return	ֹ
   */
  public int endColumn() { return _endColumn; }

  final void setFileName(String fileName) { _fileName = fileName; }

  final void setBeginPosition(Token token) {
    _beginLine = token.beginLine;
    _beginColumn = token.beginColumn;
  }

  final void setEndPosition(Token token) {
    _endLine = token.endLine;
    _endColumn = token.endColumn;
  }

  final void copyBeginPosition(Node original) {
    _beginLine = original._beginLine;
    _beginColumn = original._beginColumn;
  }

  final void copyEndPosition(Node original) {
    _endLine = original._endLine;
    _endColumn = original._endColumn;
  }

  /**
   * ʸƬ֤򼨤ʸ.
   * 
   * @return	<code>ե̾:ֹ:ֹ</code>Ȥʸ
   *		⤷եʸϤ̤Ȥ줿Ǥʤ,
   *		ե̾&gt console&ltѤ롥
   */
  public String getLocationString() {
    String filename = _fileName == null ? "<console>" : _fileName;
    return filename + ":" + beginLine() + ":" + beginColumn() + ":";
  }

  /**
   * Υ᥽åɤƤӽФȤˤä, ꤵ줿<code>NodeVisitor</code>
   * <code>visit</code>᥽åɤƤӽФ롥
   *
   * @see	ORG.ebiss.sara.parser.NodeVisitor
   */
  public abstract void accept(NodeVisitor visitor) throws Exception;

  /**
   * ʸʸˤɽ.
   * ˥ǥХåΤ˻Ѥ뤳ȤտޤƼ¸Ƥ.
   *
   * @return	ʸʸɽ
   */
  public String toString() {
    return toString(Integer.MAX_VALUE, 0);
  }

  public String toString(int maximumDepth, int currentDepth) {
    StringBuffer result = new StringBuffer();
    Class theClass = getClass();
    String name = theClass.getName();
    result.append(name.substring(name.lastIndexOf('.') + 1));
    if (maximumDepth > currentDepth) {
      result.append("(");
      Field[] fields = theClass.getFields();
      boolean first = true;
      for (int i = 0; i < fields.length; ++i) {
	if (Modifier.isFinal(fields[i].getModifiers())) continue;
	if (!first) result.append(", ");
	else first = false;
	result.append(fields[i].getName());
	try {
	  Object value = fields[i].get(this);
	  result.append('=');
	  result.
	    append(fieldValueToString(value, maximumDepth, currentDepth + 1));
	} catch (IllegalAccessException iae) {
	}
      }
      result.append(")");
    }

    return result.toString();
  }

  protected String fieldValueToString(Object value,
				      int maximumDepth, int currentDepth) {
    StringBuffer result = new StringBuffer();

    if (value == null) {
      result.append("null");
    } else if (value instanceof Node) {
      result.append(((Node)value).toString(maximumDepth, currentDepth));
    } else {
      result.append(value.toString());
    }
    return result.toString();
  }
}
