package ORG.ebiss.sara.parser;

public interface NodeVisitor {
  public void visit(Program x) throws Exception;
  public void visit(Block x) throws Exception;
  public void visit(LabeledStatement x) throws Exception;
  public void visit(EmptyStatement x) throws Exception;
  public void visit(StatementExpression x) throws Exception;
  public void visit(SwitchStatement x) throws Exception;
  public void visit(SwitchBlockStatements x) throws Exception;
  public void visit(MatchStatement x) throws Exception;
  public void visit(MatchingRule x) throws Exception;
  public void visit(IfStatement x) throws Exception;
  public void visit(WhileStatement x) throws Exception;
  public void visit(TryStatement x) throws Exception;
  public void visit(CatchClause x) throws Exception;
  public void visit(ThrowStatement x) throws Exception;
  public void visit(DoStatement x) throws Exception;
  public void visit(ForStatement x) throws Exception;
  public void visit(BreakStatement x) throws Exception;
  public void visit(ContinueStatement x) throws Exception;
  public void visit(ReturnStatement x) throws Exception;
  public void visit(AssertStatement x) throws Exception;
  public void visit(UseStatement x) throws Exception;
  public void visit(BinaryOpExpression x) throws Exception;
  public void visit(ConditionalOpExpression x) throws Exception;
  public void visit(AssignmentExpression x) throws Exception;
  public void visit(ConditionalExpression x) throws Exception;
  public void visit(UnaryOpExpression x) throws Exception;
  public void visit(IncOrDecExpression x) throws Exception;
  public void visit(VariableReference x) throws Exception;
  public void visit(VariableDefinition x) throws Exception;
  public void visit(ParenthesizedExpression x) throws Exception;
  public void visit(Literal x) throws Exception;
  public void visit(ThisExpression x) throws Exception;
  public void visit(SequenceConstruction x) throws Exception;
  public void visit(ClosureConstruction x) throws Exception;
  public void visit(ProcedureConstruction x) throws Exception;
  public void visit(ObjectConstruction x) throws Exception;
  public void visit(MethodDefinition x) throws Exception;
  public void visit(InstanceVariableDef x) throws Exception;
  public void visit(FieldAccess x) throws Exception;
  public void visit(SuperFieldAccess x) throws Exception;
  public void visit(VectorAccess x) throws Exception;
  public void visit(Invocation x) throws Exception;
  public void visit(CallCCExpression x) throws Exception;
  public void visit(LiteralPattern x) throws Exception;
  public void visit(VariablePattern x) throws Exception;
  public void visit(CatchAllPattern x) throws Exception;
  public void visit(ListPattern x) throws Exception;
  public void visit(VectorPattern x) throws Exception;
  public void visit(ObjectPattern x) throws Exception;
  public void visit(InstanceVariablePattern x) throws Exception;
  public void visit(MethodDefinitionPattern x) throws Exception;
}
