package ORG.ebiss.sara.server;

import java.io.*;
import java.net.*;
import java.util.*;

public class AcceptChangeListCommand extends ClientCommand {
  public Vector changeList = new Vector();

  public void writeObject(OldObjectOutputStream out) throws IOException {
    super.writeObject(out);
    int n = changeList.size();
    out.writeInt(n);
    for (int i = 0; i < n; ++i) {
      out.writeObject(changeList.elementAt(i));
    }
  }

  public void readObject(OldObjectInputStream in)
       throws IOException, ClassNotFoundException, IllegalAccessException,
	 InstantiationException
  {
    super.readObject(in);
    int n = in.readInt();
    changeList.removeAllElements();
    for (int i = 0; i < n; ++i) {
      changeList.addElement(in.readObject());
    }
  }

  public void execute() {
    client.acceptChangeList(changeList);
  }
}
