package ORG.ebiss.sara.server;

import java.io.*;
import java.util.*;

public abstract class Acceptor extends Thread {
  private QueueItem	_dummyHeader;
  private QueueItem	_lastItem;

  public Acceptor() {
    setName(getClass().getName());
    setDaemon(true);
    _dummyHeader = _lastItem = new QueueItem();
  }

  protected void put(Object request) {
    QueueItem item = new QueueItem();
    item.request = request;
    _lastItem.next = item;
    _lastItem = item;
  }

  protected Object get() {
    Object request = _dummyHeader.next.request;
    _dummyHeader = _dummyHeader.next;
    return request;
  }

  protected boolean isEmpty() { return _dummyHeader.next == null; }

  public synchronized void request(Object request) {
    boolean needToNotify = isEmpty();
    put(request);
    if (needToNotify) notifyAll();
  }

  public abstract void accept(Object request);

  public void run() {
    Object request = null;

    while (! isInterrupted()) {
      synchronized (this) {
	while (isEmpty()) {
	  try {
	    wait();
	  } catch (InterruptedException ie) {
	    return;
	  }
	}
	request = get();
      }
      accept(request);
    }
  }

  static public class QueueItem {
    Object	request;
    QueueItem	next;
  }
}
