package ORG.ebiss.sara.server;

import java.io.*;
import java.net.*;
import java.util.*;
import COM.objectspace.jgl.Pair;

public class AgentAdapter extends SimValueAdapter {
  protected Hashtable	_auxiliaryObjects = new Hashtable(19);

  public AgentAdapter(String hostname, String id)
       throws UnknownHostException, IOException
  {
    attach(new Client(hostname), id);
    _client.registerAdapter(id, this);
    _client.getAgentState(id);
  }

  protected String[] decodeAuxType(String type) {
    StringTokenizer tokeizer = new StringTokenizer(type, "\0", false);
    int count = tokeizer.countTokens();
    String[] result = new String[count];
    for (int i = 0; i < count; ++i) {
      result[i] = tokeizer.nextToken();
    }
    return result;
  }

  public synchronized void addObserver(RemoteObserver observer) {
    super.addObserver(observer);
    for (Enumeration e = _auxiliaryObjects.elements(); e.hasMoreElements(); ) {
      Pair pair = (Pair)e.nextElement();
      ((RemoteAgentObserver)observer).
	acceptAuxiliaryObject(this,
			      (SimValueAdapter)pair.first,
			      decodeAuxType((String)pair.second));
    }
  }

  public synchronized void auxiliaryObjectCreated(String type, String auxId) {
    SimValueAdapter adapter = _client.getAdapter(auxId);
    _auxiliaryObjects.put(auxId, new Pair(adapter, type));
    for (Enumeration e = _observers.elements(); e.hasMoreElements(); ) {
      ((RemoteAgentObserver)e.nextElement()).
	acceptAuxiliaryObject(this, adapter, decodeAuxType(type));
    }
  }

  public synchronized
  void auxiliaryObjectDestroyed(String type, String auxId) {
    _auxiliaryObjects.remove(auxId);
    SimValueAdapter adapter = _client.getAdapter(auxId);
    for (Enumeration e = _observers.elements(); e.hasMoreElements(); ) {
      ((RemoteAgentObserver)e.nextElement()).
	retractAuxiliaryObject(this, adapter, decodeAuxType(type));
    }
    _client.removeAdapter(auxId);
  }
}
