package ORG.ebiss.sara.server;

import java.io.*;
import java.util.*;
import ORG.ebiss.sara.interpreter.*;

public class Change implements Transportable {
  public final static int	ADD = 1;
  public final static int	REMOVE = 2;
  public final static int	MODIFY = 3;
  public final static int	DUMP = 4;

  public String			id;
  public int			type;
  public String			slotName;
  public String			label;
  public boolean		visible;
  public boolean		action;
  public UIObject	value;

  public String toString() {
    return "Change(" + id + ", type=" + type + ", slot=" + slotName +
      ", label=" + label + ", visible = " + visible + ", action=" +
      action + (value != null ? ", value=" + value.toString() : "");
  }

  public void writeObject(OldObjectOutputStream out) throws IOException {
    out.writeUTF(id);
    out.writeInt(type);
    out.writeUTF(slotName);
    out.writeUTF(label);
    out.writeBoolean(visible);
    out.writeBoolean(action);
    out.writeBoolean(value != null);
    if (value != null) out.writeObject(value);
  }

  public void readObject(OldObjectInputStream in)
       throws IOException, ClassNotFoundException, IllegalAccessException,
	 InstantiationException
  {
    id = in.readUTF();
    type = in.readInt();
    slotName = in.readUTF();
    label = in.readUTF();
    visible = in.readBoolean();
    action = in.readBoolean();
    if (in.readBoolean()) {
      value = (UIObject)in.readObject();
    }
  }
}
