package ORG.ebiss.sara.server;

import java.io.*;

public abstract class Command implements Transportable {
  private static Object	_lock = new Object();
  private static int	_counter;
  private int		_stamp;

  public int stamp() {
    if (_stamp != 0) return _stamp;
    synchronized (_lock) {
      return _stamp = ++_counter;
    }
  }

  public void validateStamp() {
    if (_stamp == 0) throw new RuntimeException(getClass().getName());
  }

  public void writeObject(OldObjectOutputStream out) throws IOException {
    out.writeInt(_stamp);
  }

  public void readObject(OldObjectInputStream in)
       throws IOException, ClassNotFoundException, IllegalAccessException,
	 InstantiationException
  {
    _stamp = in.readInt();
  }
}
