package ORG.ebiss.sara.server;

import java.io.*;
import java.util.*;

public class FloatParam implements UIObject {
  public String		label;
  public double		value;
  public double		min;
  public double		max;

  public void writeObject(OldObjectOutputStream out) throws IOException {
    out.writeUTF(label);
    out.writeDouble(value);
    out.writeDouble(min);
    out.writeDouble(max);
  }

  public void readObject(OldObjectInputStream in)
       throws IOException, ClassNotFoundException, IllegalAccessException,
	 InstantiationException
  {
    label = in.readUTF();
    value = in.readDouble();
    min = in.readDouble();
    max = in.readDouble();
  }

  public String toString() { return Double.toString(value); }

  public String getDescription() {
    if (label == null) throw new RuntimeException();
    return label;
  }

  public int getType() {
    return IS_A_FLOAT_PARAM;
  }

  public void setValueOf(String svalue) {
    value = Double.valueOf(svalue).doubleValue();
  }

  public void setRange(double min, double max) {
    this.min = min;
    this.max = max;
  }

  public float getMin() { return (float)min; }

  public float getMax() { return (float)max; }
}
