package ORG.ebiss.sara.server;

import java.io.*;
import java.util.*;

public class IntegerParam implements UIObject {
  public String		label;
  public int		value;
  public int		min;
  public int		max;

  public void writeObject(OldObjectOutputStream out) throws IOException {
    out.writeUTF(label);
    out.writeInt(value);
    out.writeInt(min);
    out.writeInt(max);
  }

  public void readObject(OldObjectInputStream in)
       throws IOException, ClassNotFoundException, IllegalAccessException,
	 InstantiationException
  {
    label = in.readUTF();
    value = in.readInt();
    min = in.readInt();
    max = in.readInt();
  }

  public String toString() { return Integer.toString(value); }

  public String getDescription() {
    if (label == null) throw new RuntimeException();
    return label;
  }

  public int getType() {
    return IS_A_INTEGER_PARAM;
  }

  public void setValueOf(String svalue) {
    value = Integer.valueOf(svalue).intValue();
  }

  public void setRange(int min, int max) {
    this.min = min;
    this.max = max;
  }

  public int getMin() { return min; }

  public int getMax() { return max; }
}
