package ORG.ebiss.sara.server;

import java.io.*;
import java.net.*;
import java.util.*;
import ORG.ebiss.sara.interpreter.*;

public class LoadGenerator implements Runnable, RemoteAgentObserver {
  AgentAdapter	adapter;
  Vector	interactions = new Vector();

  public LoadGenerator() throws UnknownHostException, IOException {
    adapter = new AgentAdapter("localhost", "test");
    adapter.addObserver(this);
  }

  public void run() {
    Interaction interaction = null;
    Random random = new Random();
    try {
      for (;;) {
	synchronized (this) {
	  while (interactions.isEmpty()) {
	    try {
	      wait();
	    } catch (InterruptedException ie) {
	    }
	  }
	  int seed = random.nextInt();
	  int index = (seed < 0 ? -seed : seed) % interactions.size();
	  interaction = (Interaction)interactions.elementAt(index);
	}
	adapter.execute(interaction.createAction());
	System.out.println("Tick");
      }
    } catch (Exception e) {
      e.printStackTrace();
    }
  }

  public synchronized void acceptProperty(SimValueAdapter adapter,
					  String name,
					  UIObject property) {
    try {
      Thread.sleep(500);
    } catch (InterruptedException ie) {
    }
  }

  public synchronized void retractProperty(SimValueAdapter adapter,
					   String name) {
    try {
      Thread.sleep(500);
    } catch (InterruptedException ie) {
    }
  }

  public synchronized void acceptInteraction(SimValueAdapter adapter,
					     Interaction i) {
    if (interactions.isEmpty()) notifyAll();
    try {
      Thread.sleep(500);
    } catch (InterruptedException ie) {
    }
    interactions.addElement(i);
  }

  public synchronized void retractInteraction(SimValueAdapter adapter,
					      Interaction i) {
    try {
      Thread.sleep(500);
    } catch (InterruptedException ie) {
    }
    interactions.removeElement(i);
  }

  public synchronized void acceptInformation(AgentAdapter adapter,
					     UIObject contents) {
    try {
      Thread.sleep(500);
    } catch (InterruptedException ie) {
    }
  }

  public synchronized void acceptSitProperty(AgentAdapter adapter, String name,
					     UIObject resource) {
    try {
      Thread.sleep(500);
    } catch (InterruptedException ie) {
    }
  }

  public synchronized void retractSitProperty(AgentAdapter adapter,
					      String name) {
    try {
      Thread.sleep(500);
    } catch (InterruptedException ie) {
    }
  }

  public synchronized void acceptYoukyuu(AgentAdapter adapter,
					 SimValueAdapter youkyuuAdapter,
					 String youkyuuObjectId) {
    try {
      Thread.sleep(500);
    } catch (InterruptedException ie) {
    }
  }

  public synchronized void retractYoukyuu(AgentAdapter adapter,
					  SimValueAdapter youkyuuAdapter,
					  String youkyuuObjectId) {
    try {
      Thread.sleep(500);
    } catch (InterruptedException ie) {
    }
  }

  public static void main(String args[]) throws Exception {
    int n = Integer.parseInt(args[0]);
    for (int i = 0; i < n; ++i) {
      LoadGenerator load = new LoadGenerator();
      Thread thread = new Thread(load);
      thread.start();
    }
  }
}
