package ORG.ebiss.sara.server;

import java.io.*;
import java.net.*;
import java.util.*;

public class NewsConnection {
  protected Socket		_socket;
  protected PrintWriter		_writer;
  protected BufferedReader	_reader;

  public NewsConnection(String hostname, int portNumber)
       throws UnknownHostException, IOException, UnsupportedEncodingException
  {
    _socket = new Socket(hostname, portNumber);
    _writer = new PrintWriter
      (new OutputStreamWriter(_socket.getOutputStream(), "JIS"), true);
    _reader = new BufferedReader
      (new InputStreamReader(_socket.getInputStream(), "JIS"));
  }

  public Result readStatus() throws EOFException, IOException {
    Result result = new Result();
    String resultText = _reader.readLine();
    if (resultText == null) throw new EOFException();
    String resultCodeString = resultText.substring(0, 3);
    try {
      result.code = Integer.parseInt(resultCodeString);
    } catch (NumberFormatException nfe) {
      throw new IOException(nfe.getMessage());
    }
    result.codeChars = resultCodeString.toCharArray();
    result.text = resultText.substring(3);
    return result;
  }

  public Result sendCommand(String command)
       throws EOFException, IOException
  {
    _writer.print(command);
    _writer.print("\r\n");
    _writer.flush();
    return readStatus();
  }

  public Result sendMessage(String message)
       throws EOFException, IOException {
    String line = null;
    BufferedReader reader = new BufferedReader(new StringReader(message));
    while ((line = reader.readLine()) != null) {
      if (line.equals(".")) {
	_writer.print("..\r\n");
      } else {
	_writer.print(line);
	_writer.print("\r\n");
      }
    }
    _writer.print(".\r\n");
    _writer.flush();
    return readStatus();
  }

  public Result post(String message) throws IOException, EOFException {
    Result result = sendCommand("post");
    if (result.code != 340) return result;
    return sendMessage(message);
  }

  public static class Result {
    public int		code;
    public char[]	codeChars;
    public String	text;
  }
}
