package ORG.ebiss.sara.server;

import java.io.*;
import java.net.*;
import java.util.*;

class NotifyExtendedInfoCommand extends ClientCommand {
  String	agentId;
  String[]	type;
  UIObject	info;

  public void writeObject(OldObjectOutputStream out) throws IOException {
    super.writeObject(out);
    out.writeUTF(agentId);
    out.writeInt(type.length);
    for (int i = 0; i < type.length; ++i) {
      out.writeUTF(type[i]);
    }
    out.writeObject(info);
  }

  public void readObject(OldObjectInputStream in)
       throws IOException, ClassNotFoundException, IllegalAccessException,
	 InstantiationException
  {
    super.readObject(in);
    agentId = in.readUTF();
    int typesize = in.readInt();
    type = new String[typesize];
    for (int i = 0; i < typesize; ++i) {
      type[i] = in.readUTF();
    }
    info = (UIObject)in.readObject();
  }

  public void execute() {
    client.getAdapter(agentId).acceptExtendedInformation(type, info);
  }
}
