package ORG.ebiss.sara.server;

import java.io.*;
import java.net.*;
import java.util.*;

/**
 * ̿ݡ.
 * 
 * @see	
 * @version	1.0 Oct 1997
 * @author	TOGAWA Atsushi
 */
public abstract class Port {
  /* ˴ؤ륳
   *
   * o deadlock
   *   , Port -> Sender, Receiver -> Port ȤܹԤ롥
   *   SenderؤΥ塼󥰤ϥ֥åʤ
   */

  protected static Object	_portClassLock = new Object();
  protected static PortReaper	_portReaper = null;

  protected boolean	_running;
  protected Socket	_socket;
  protected Sender	_sender;
  protected Receiver	_receiver;
  protected Hashtable	_replyKs; // key(is a Integer) -> reply continuation

  public Port() {
    synchronized (_portClassLock) {
      if (_portReaper == null || !_portReaper.isAlive()) {
	_portReaper = new PortReaper();
	_portReaper.start();
      }
    }
  }

  protected Sender createSender() throws IOException {
    return new Sender(this, _socket);
  }

  protected Receiver createReceiver() throws IOException {
    return new Receiver(this, _socket);
  }

  public synchronized void open(Socket socket) {
    try {
      _socket = socket;
      _replyKs = new Hashtable();
      _sender = createSender();
      _receiver = createReceiver();
      _sender.start();
      _receiver.start();
      _running = true;
    } catch (IOException ioe) {
      ioe.printStackTrace();
      close();
    }
  }

  public synchronized Socket socket() {
    return _receiver == null ? null : _socket;
  }

  /**
   * ݡȤĤ.
   */
  public void close() {
    int retryCount = 0;
    if (!_running) return;
    synchronized (this) {
      _portReaper.request(this);
      while (_running) {
	try {
	  wait(1000);
	} catch (InterruptedException ie) {
	}
	if (++retryCount > 3) shutdown();
      }
    }
  }

  /**
   * ݡȤѴ. Υ᥽åɤPortReaperʳƤӽФƤϤʤʤ.
   * 
   * @see	ORG.ebiss.sara.server.PortReaper
   */
  void shutdown() {
    Receiver	receiver;
    Sender	sender;
    Socket	socket;
    Hashtable	replyKs;

    synchronized (this) {
      receiver = _receiver;
      sender = _sender;
      socket = _socket;
      replyKs = _replyKs;
      if (receiver != null) receiver.stop();
      if (sender != null) sender.stop();
      _receiver = null;
      _sender = null;
      _socket = null;
      _replyKs = null;
      _running = false;
      notifyAll();
    }
    try { if (receiver != null) receiver.join(); } catch (Exception e) {}
    try { if (sender != null) sender.join(); } catch (Exception e) {}
    try { if (socket != null) socket.close(); } catch (Exception e) {}
    if (replyKs != null) {
      for (Enumeration e = replyKs.elements(); e.hasMoreElements(); ) {
	((Continuation) e.nextElement()).failed();
      }
    }
  }

  /**
   * PortReaper߽ΰԤ. PortReaperʳƤӽФƤϤʤʤ.
   * 
   * @param reaper	PortReaper
   * @see	ORG.ebiss.sara.server.PortReaper
   */
  static void removePortReaper(PortReaper reaper) {
    synchronized (Port._portClassLock) {
      if (Port._portReaper == reaper) Port._portReaper = null;
    }
  }

  /**
   * RPCԤ. ³ۥȤФƥޥɤμ¹Ԥꤹ.
   * 
   * @param command		³ۥȤˤƼ¹Ԥޥ
   * @param continuation	ֿå륪֥
   */
  public synchronized
  void request(Command command, Continuation continuation) {
    if (_sender == null) continuation.failed();
    Integer key = new Integer(command.stamp());
    _replyKs.put(key, continuation);
    _sender.request(command);
  }

  /**
   * ³ۥȤФƥޥɤμ¹Ԥꤹ.
   *
   * @param command	³ۥȤˤƼ¹Ԥޥ
   */
  public synchronized void send(Command command) {
    if (_sender == null) return;
    _sender.request(command);
  }

  /**
   * å.
   * 
   * @param command	å
   */
  public abstract void accept(Command command);

  /**
   * ץ饤å夷ȤΤ餻.
   * Υ᥽åɤθƤӽФˤäơ<code>key</code>б
   * <code>request</code>᥽åɤcontinuation¹Ԥ.
   *
   * Υ᥽åɤReceiveråɰʳƤӽФƤϤʤʤ
   * 
   * @param key		<code>call</code>ޥɤΥ.
   * @param message	<code>call</code>᥽åɤͤȤʤ륪֥
   */
  public synchronized void acknowledge(int key, Object message) {
    /* shutdownϤΥ᥽åɤReceiver threadʳƤӽФʤ
     * Ȥ˥ǥ󥰤Ƥ롥*/

    Continuation continuation =
      (Continuation)_replyKs.remove(new Integer(key));
    if (continuation != null) continuation.succeeded(message);
  }
}
