package ORG.ebiss.sara.server;

import java.io.*;
import java.util.*;
import ORG.ebiss.sara.interpreter.Value;

public class Statement implements UIObject {
  public String	sender;
  public String	contents;

  public Statement() {}

  public Statement(String sender, String value) {
    this.sender = sender;
    contents = value;
  }

  public void writeObject(OldObjectOutputStream out) throws IOException {
    out.writeUTF(sender);
    out.writeUTF(contents);
  }

  public void readObject(OldObjectInputStream in)
       throws IOException, ClassNotFoundException, IllegalAccessException,
	 InstantiationException
  {
    sender = in.readUTF();
    contents = in.readUTF();
  }

  public String toString() { return contents; }

  public String getDescription() {
    throw new RuntimeException();
  }

  public int getType() {
    return IS_A_STATEMENT;
  }

  public String getSender() { return sender; }

  public String getContents() { return contents; }

  public void setValueOf(String value) {
    throw new RuntimeException("Statement.setValueOf() is not implemented");
  }
}
