package ORG.ebiss.sara.server;

import java.io.*;
import java.net.*;
import java.util.*;

public class Sync implements Continuation {
  private Object 	_result;
  private boolean	_replied;
  private boolean	_error;
  private ClientPort	_port;

  public Sync(ClientPort port) { _port = port; }

  public synchronized Object call(ServerCommand command) throws IOException {
    _port.request(command, this);
    while (!_replied) {
      try {
	wait();
      } catch (InterruptedException ie) {
	return null;
      }
    }
    if (_error) throw new IOException();
    return _result;
  }

  public synchronized void succeeded(Object result) {
    _result = result;
    _replied = true;
    _error = false;
    notifyAll();
  }

  public synchronized void failed() {
    _result = null;
    _replied = true;
    _error = true;
    notifyAll();
  }
}
