package ORG.ebiss.sara.server;

import ORG.ebiss.sara.interpreter.*;

public final class Timer extends Thread {
  private boolean		_restart;
  private Interactor		_interactor;
  private final static Value[]	_arguments = {};
  private int			_period = 10000;
  private boolean		_running = true;
  public ApplicableValue	expired;

  public Timer(Interactor interactor) {
    _interactor = interactor;
    setName(getClass().getName());
    setDaemon(true);
    start();
  }

  public int getPeriod() { return _period; }

  public void setPeriod(int period) {
    _period = period;
    restart();
  }

  public boolean isRunning() { return _running; }

  public void setRunning(boolean value) {
    _running = value;
    restart();
  }

  public synchronized void restart() {
    _restart = true;
    notifyAll();
    interrupt();
  }

  public void run() {
    for (;;) {
      synchronized (this) {
	long goOffAt =
	  _running ? System.currentTimeMillis() + _period : Long.MAX_VALUE;
	while (!_restart && System.currentTimeMillis() < goOffAt) {
	  long time = goOffAt - System.currentTimeMillis();
	  if (time > Integer.MAX_VALUE) time = Integer.MAX_VALUE;
	  try {
	    wait(time);
	  } catch (InterruptedException ie) {
	  }
	}
      }
      if (!_restart && expired != null && _running &&
	  expired instanceof ApplicableValue) {
	_interactor.execute(expired, _arguments);
      }
      _restart = false;
    }
  }
}

