package ORG.ebiss.sara.server;

import java.io.*;
import java.util.*;

public class UIAtomic implements UIObject {
  public int		type;
  public String		label;
  public Object		value;

  public void writeObject(OldObjectOutputStream out) throws IOException {
    out.writeUTF(label);
    out.writeInt(type);
    out.writeBoolean(value != null);
    if (value != null) out.writeObject(value);
  }

  public void readObject(OldObjectInputStream in)
       throws IOException, ClassNotFoundException, IllegalAccessException,
	 InstantiationException
  {
    label = in.readUTF();
    type = in.readInt();
    if (in.readBoolean()) value = in.readObject();
  }

  public String toString() { return value.toString(); }

  public String getDescription() {
    if (label == null) throw new RuntimeException();
    return label;
  }

  public int getType() {
    if (type == 0) throw new RuntimeException();
    return type;
  }

  public void setValueOf(String svalue) {
    switch (type) {
    case IS_A_INTEGER:
      value = Integer.valueOf(svalue);
      break;
    case IS_A_FLOAT:
      value = Double.valueOf(svalue);
      break;
    case IS_A_SHORT_STRING:
    case IS_A_LONG_STRING:
    case IS_A_LABEL:
    case IS_A_TEXT:
      value = svalue;
      break;
    default:
      throw new RuntimeException(Integer.toString(type));
    }
  }
}
