package ORG.ebiss.sara.server;

import java.io.*;
import java.util.*;

public class UIContainer implements CompositeUIObject {
  public String	description;
  public String	className;
  public Vector	values;

  public void writeObject(OldObjectOutputStream out) throws IOException {
    out.writeUTF(description);
    out.writeUTF(className);
    out.writeInt(values.size());
    for (Enumeration e = values.elements(); e.hasMoreElements(); ) {
      out.writeObject(e.nextElement());
    }
  }

  public void readObject(OldObjectInputStream in)
       throws IOException, ClassNotFoundException, IllegalAccessException,
	 InstantiationException
  {
    description = in.readUTF();
    className = in.readUTF();
    int n = in.readInt();
    values = new Vector(n);
    for (int i = 0; i < n; ++i) {
      values.addElement(in.readObject());
    }
  }

  public String getDescription() { return description; }

  public int getType() { return IS_COMPOSITE; }

  public void setValueOf(String value) {
    throw new RuntimeException("unsupported operation: setValueOf(String)");
  }

  public String toString() {
    StringBuffer buffer = new StringBuffer("[");
    int n = values.size();
    for (int i = 0; i < n; ++i) {
      if (i > 0) buffer.append(", ");
      buffer.append(values.elementAt(i).toString());
    }
    buffer.append("]");
    return buffer.toString();
  }

  public Enumeration elements() { return values.elements(); }
}
