package ORG.ebiss.sara.server;

import java.io.*;
import java.util.*;

public class UIRecord implements CompositeUIObject {
  public String 	description;
  public Hashtable	values;

  public void writeObject(OldObjectOutputStream out) throws IOException {
    out.writeUTF(description);
    out.writeInt(values.size());
    for (Enumeration e = values.keys(); e.hasMoreElements(); ) {
      String key = (String)e.nextElement();
      out.writeUTF(key);
      out.writeObject(values.get(key));
    }
  }

  public void readObject(OldObjectInputStream in)
       throws IOException, ClassNotFoundException, IllegalAccessException,
	 InstantiationException
  {
    description = in.readUTF();
    int n = in.readInt();
    values = new Hashtable(n, 1.0f);
    for (int i = 0; i < n; ++i) {
      String key = in.readUTF();
      values.put(key, in.readObject());
    }
  }

  public String getDescription() { return description; }

  public int getType() { return IS_COMPOSITE; }

  public void setValueOf(String value) {
    throw new RuntimeException("unsupported operation: setValueOf(String)");
  }

  public String toString() {
    StringBuffer buffer = new StringBuffer("[");
    Enumeration e = values.keys();
    if (e.hasMoreElements()) {
      String key = (String)e.nextElement();
      buffer.append(key);
      buffer.append("=");
      buffer.append(values.get(key).toString());
      while (e.hasMoreElements()) {
	buffer.append(", ");
	key = (String)e.nextElement();
	buffer.append(key);
	buffer.append("=");
	buffer.append(values.get(key).toString());
      }
    }
    buffer.append("]");
    return buffer.toString();
  }

  public Enumeration elements() { return values.elements(); }
}
